import { createStore } from 'vuex'
import dashboard from './dashboard/index.js'

const store = createStore({
    state () {
        return {
            Session: {
                Token: null,
                User: null
            },
        }
    },
    mutations: {
        initializeStore(state) {
            let store = localStorage.getItem("store");
            if(store){
                this.replaceState(
                    Object.assign(state, JSON.parse(store))
                );
            }
        },
        setTitle (state, title) {
            document.title = "Budgeteer - " + title;
        },
        setToken(state, token) {
            state.Session.Token = token;
        }
    },
    modules: {
        dashboard
    }
})

store.subscribe((mutation, state) => {
    let persistedState = {
        Session: state.Session,
        Budgets: state.Budgets,
        CurrentBudget: state.CurrentBudget
    }
    localStorage.setItem("store", JSON.stringify(persistedState));
})

export default store